SystemOrganization addCategory: #'BlackBoxParser-Expression'!
SystemOrganization addCategory: #'BlackBoxParser-test'!
SystemOrganization addCategory: #BlackBoxParser!

Object subclass: #BBExpression
	uses: ClassCheckingHashProofTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

BBExpression class
	uses: ClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

BBExpression subclass: #BBBinaryExpression
	instanceVariableNames: 'left right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

BBBinaryExpression subclass: #BBAdd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

!BBBinaryExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:12'!
gettersForEquality
	
	^#(left right)! !

!BBBinaryExpression methodsFor: 'accessing' stamp: 'hjo 8/11/2012 21:15'!
left

	^left! !

!BBBinaryExpression methodsFor: 'accessing' stamp: 'hjo 8/11/2012 16:54'!
left: aBBNumber 

	left := aBBNumber! !

!BBBinaryExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:15'!
right

	^right! !

!BBBinaryExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 16:55'!
right: aBBNumber 

	right := aBBNumber! !

BBBinaryExpression subclass: #BBDivide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

BBExpression subclass: #BBNumber
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

!BBNumber methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:10'!
gettersForEquality

	^#(number)! !

!BBNumber methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:10'!
number

	^number! !

!BBNumber methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 16:54'!
number: aNumber 

	number := aNumber! !

BBExpression subclass: #BBParenthesis
	instanceVariableNames: 'inner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

!BBParenthesis methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 18:54'!
gettersForEquality

	^#(inner)! !

!BBParenthesis methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 18:55'!
inner 

	^inner! !

!BBParenthesis methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 16:55'!
inner: aBBAdd 

	inner := aBBAdd! !

BBExpression subclass: #BBTerm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

BBExpression subclass: #BBVacancy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

Object subclass: #BlackBoxParser
	instanceVariableNames: 'stream stack parsingDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser'!

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 18:38'!
initialize

	super initialize.
	"stream := '(1+2)/3' readStream."
	stack := OrderedCollection new.
	self makeParsingDictionary.! !

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 18:35'!
makeParsingDictionary

	parsingDictionary := Dictionary new.
	
	parsingDictionary 
		at: $( put: 
		[stream next.
		stack addFirst: BBParenthesis new].

	parsingDictionary 
		at: $1 put: 
		[stream next.
		stack addFirst: (BBNumber new number: 1)].

	parsingDictionary at: $+ put: 
		[stream next.
		stack addFirst: (BBAdd new left: (stack removeFirst))].

	parsingDictionary at: $2 put: 
		[stream next.
		stack first right: (BBNumber new number: 2)].

	parsingDictionary at: $) put: 
		[ | inex | stream next.
		inex := stack removeFirst.
		stack first inner: inex ].

	parsingDictionary at: $/ put: 
		[stream next.
		stack addFirst: (BBDivide new left: (stack removeFirst))].

	parsingDictionary at: $3 put: 
		[stream next.
		stack first right: (BBNumber new number:3)].! !

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:07'!
run

	[self step] whileTrue.! !

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 18:41'!
sourceString: aString 

	stream := aString readStream.! !

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 16:53'!
stack

	^ stack! !

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 17:02'!
step

	stream atEnd ifTrue: [^false].
	(parsingDictionary at: stream peek) value.
	^true! !

TestCase subclass: #BlackBoxParserTest
	instanceVariableNames: 'parser expectedStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-test'!

!BlackBoxParserTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:08'!
setUp

	parser := BlackBoxParser new.
	"parser sourceString: '(1+2)/3'."
	
	expectedStack := OrderedCollection new.! !

!BlackBoxParserTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:08'!
testStep0

	parser sourceString: ''.
	parser run.
	self assert: expectedStack equals: parser stack.! !

!BlackBoxParserTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:08'!
testStep1

	parser sourceString: '('.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	self assert: expectedStack equals: parser stack.! !

!BlackBoxParserTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:09'!
testStep2

	parser sourceString: '(1'.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBNumber new number: 1).
	self assert: expectedStack equals: parser stack.! !

!BlackBoxParserTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:11'!
testStep3

	parser sourceString: '(1+'.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBAdd new left: (BBNumber new number: 1)).
	self assert: expectedStack equals: parser stack.! !

!BlackBoxParserTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:17'!
testStep4

	parser sourceString: '(1+2'.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBAdd new left: (BBNumber new number: 1); right: (BBNumber new number: 2)).
	self assert: expectedStack equals: parser stack.! !

!BlackBoxParserTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:17'!
testStep5

	parser sourceString: '(1+2)'.
	parser run.
	expectedStack addFirst: (BBParenthesis new inner: (BBAdd new left: (BBNumber new number: 1); right: (BBNumber new number: 2))).
	self assert: expectedStack equals: parser stack.! !

!BlackBoxParserTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:18'!
testStep6

	parser sourceString: '(1+2)/'.
	parser run.
	expectedStack addFirst: (BBDivide new left: (BBParenthesis new inner: (BBAdd new left: (BBNumber new number: 1); right: (BBNumber new number: 2)))).
	self assert: expectedStack equals: parser stack.! !

!BlackBoxParserTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:19'!
testStep7

	parser sourceString: '(1+2)/3'.
	parser run.
	expectedStack addFirst: (BBDivide new left: (BBParenthesis new inner: (BBAdd new left: (BBNumber new number: 1); right: (BBNumber new number: 2))); right: (BBNumber new number: 3)).
	self assert: expectedStack equals: parser stack.! !
